* [Universal Render Pipeline](index.md)
* [Requirements](requirements)
  * [Building for Closed platform](Building-For-Consoles.md)
* [What's new in URP 10](whats-new/urp-whats-new.md)
* [Features]()
  * [Feature Comparison with the Built-in Render Pipeline](universalrp-builtin-feature-comparison.md)
* [Getting started](InstallingAndConfiguringURP.md)
  * [Create a Project from a Template](creating-a-new-project-with-urp.md)
  * [Install URP into an existing Project](InstallURPIntoAProject.md)
* [Render Pipeline Concepts](urp-concepts.md)
  * [The URP Asset](universalrp-asset.md)
  * [Forward Renderer](urp-forward-renderer.md)
  * [Renderer Feature](urp-renderer-feature.md)
    * [How to add a Renderer Feature](urp-renderer-feature-how-to-add.md)
    * [Render Objects Renderer Feature](renderer-features/how-to-custom-effect-render-objects.md)
    * [Ambient Occlusion](post-processing-ssao.md)
* [Upgrade guides](upgrade-guides.md)
  * [Upgrading to URP 10.7.x](upgrade-guide-10-7-x.md)
  * [Upgrading to URP 10.6.x](upgrade-guide-10-6-x.md)
  * [Upgrading to URP 10.5.x](upgrade-guide-10-5-x.md)
  * [Upgrading to URP 10.4.x](upgrade-guide-10-4-x.md)
  * [Upgrading to URP 10.3.x](upgrade-guide-10-3-x.md)
  * [Upgrading to URP 10.2.x](upgrade-guide-10-2-x.md)
  * [Upgrading to URP 10.1.x](upgrade-guide-10-1-x.md)
  * [Upgrading to URP 10.0.x](upgrade-guide-10-0-x.md)
  * [Upgrading to URP 9.0.x](upgrade-guide-9-0-x.md)
  * [Upgrading to URP 8.2.0](upgrade-guide-8-2-0.md)
  * [Upgrading to URP 8.1.0](upgrade-guide-8-1-0.md)
  * [Upgrading to URP 8.0.0](upgrade-guide-8-0-0.md)
  * [Upgrading to URP 7.4.0](upgrade-guide-7-4-0.md)
  * [Upgrading to URP 7.3.0](upgrade-guide-7-3-0.md)
  * [Upgrading to URP 7.2.0](upgrade-guide-7-2-0.md)
  * [Upgrading from LWRP to URP](upgrade-lwrp-to-urp.md)
* [Rendering](rendering-in-universalrp.md)
  * [How to use Render Objects Renderer Feature](renderer-features/how-to-custom-effect-render-objects.md)
* [Lighting](lighting.md)
  * [Light component reference](light-component)
  * [Lighting Mode](urp-lighting-mode.md)
  * [The Universal Additional Light Data component](universal-additional-light-data.md)
* [Cameras](cameras.md)
  * [The Universal Additional Camera Data component](universal-additional-camera-data.md)
  * [Render Type](camera-types-and-render-type.md)
  * [Working with multiple cameras](cameras-multiple.md)
    * [Camera Stacking](camera-stacking.md)
    * [Rendering from multiple Cameras to the same render target](rendering-to-the-same-render-target.md)
    * [Rendering to a Render Texture](rendering-to-a-render-texture.md)
  * [Clearing, rendering order and overdraw](cameras-advanced.md)
  * [Camera component reference](camera-component-reference.md)

* [Post-processing](integration-with-post-processing.md)
  * [How to configure](integration-with-post-processing.md#post-proc-how-to)
  * [Volumes](Volumes.md)
    * [Volume Profile](VolumeProfile.md)
    * [Volume Overrides](VolumeOverrides.md)
  * [Effect List](EffectList.md)
    * [Ambient Occlusion](post-processing-ssao.md)
    * [Bloom](post-processing-bloom.md)
    * [Channel Mixer](Post-Processing-Channel-Mixer.md)
    * [Chromatic Aberration](post-processing-chromatic-aberration.md)
    * [Color Adjustments](Post-Processing-Color-Adjustments.md)
    * [Color Curves](Post-Processing-Color-Curves.md)
    * [Depth of Field](post-processing-depth-of-field.md)
    * [Film Grain](Post-Processing-Film-Grain.md)
    * [Lens Distortion](Post-Processing-Lens-Distortion.md)
    * [Lift, Gamma, and Gain](Post-Processing-Lift-Gamma-Gain.md)
    * [Motion Blur](Post-Processing-Motion-Blur.md)
    * [Panini Projection](Post-Processing-Panini-Projection.md)
    * [Shadows Midtones Highlights](Post-Processing-Shadows-Midtones-Highlights.md)
    * [Split Toning](Post-Processing-Split-Toning.md)
    * [Tonemapping](post-processing-tonemapping.md)
    * [Vignette](post-processing-vignette.md)
    * [White Balance](Post-Processing-White-Balance.md)

* [Shaders and Materials](shaders-in-universalrp.md)
  * [Shading Models](shading-model.md)
  * [Complex Lit](shader-complex-lit.md)
  * [Lit](lit-shader.md)
  * [Simple Lit](simple-lit-shader.md)
  * [Baked Lit](baked-lit-shader.md)
  * [Unlit](unlit-shader.md)
  * [Particles Lit](particles-lit-shader.md)
  * [Particles Simple Lit](particles-simple-lit-shader.md)
  * [Particles Unlit](particles-unlit-shader.md)
  * [Upgrading shaders from Built-in](upgrading-your-shaders.md)
  * [Shader stripping](shader-stripping.md)
  * [Writing custom shaders](writing-custom-shaders-urp.md)
    * [Creating a sample scene](writing-shaders-urp-basic-prerequisites.md)
    * [URP basic unlit shader](writing-shaders-urp-basic-unlit-structure.md)
    * [URP unlit shader with color input](writing-shaders-urp-unlit-color.md)
    * [Drawing a texture](writing-shaders-urp-unlit-texture.md)
    * [Visualizing normal vectors](writing-shaders-urp-unlit-normals.md)
    * [Reconstruct the world space positions](writing-shaders-urp-reconstruct-world-position.md)
  * [URP ShaderLab Pass tags](urp-shaders/urp-shaderlab-pass-tags.md)
* [Customizing URP](customizing-urp.md)
  * [beginCameraRendering event](using-begincamerarendering.md)

* [2D](2d-index.md)
  * [Introduction to Lights 2D](Lights-2D-intro.md)
  * [Requirements and setup](Setup.md)
  * [Preparing and upgrading](PrepShader.md)
  * [Normal map and mask Textures](SecondaryTextures.md)
  * [Lights 2D properties](2DLightProperties.md)

    * [Light types](LightTypes.md)
  * [2D Shadows](2DShadows.md)
  * [Configuring the 2D Renderer Asset](2DRendererData_overview.md)

    * [HDR emulation scale](HDREmulationScale.md)
    * [Light Blend Styles](LightBlendStyles.md)

  * [2D Renderer and Shader Graph](ShaderGraph.md)
  * [2D Pixel Perfect](2d-pixelperfect.md)
    * [Cinemachine Pixel Perfect extension](pixel-cinemachine.md)

* [Frequently asked questions (FAQ)](faq.md)
* [Known issues](known-issues.md)
